<template>

  <nav id="rps-header" class="rps-header">
    <div class="rps-header-container">
      <Logo :src="config.logo_src" :href="config.logo_link" :login="userinfo"/>

      <div class="mobile-nav-toggle">
        <ul>
          <ToggleButton :options="this.toggleButtonConfig"></ToggleButton>
        </ul>
      </div>

      <div class="mobile-nav-button" @click="menuToggle()">
        <Icon :icon="menuIsOpen ? 'xmark':'bars'"/>
      </div>

      <div class="nav-menu" :class="menuIsOpen ? 'show-mobile' : ''">
        <ul class="nav-top">
          <li v-for="(menuitem, indext) in config.top_navbar_links" v-bind:key="indext"
              :class="menuitem.class">
            <a :href="menuitem.link" class="authButton" :style="menuitem.style">
              {{ menuitem.title }}
              <Icon :icon="[config.iconStyle, menuitem.icon]"/>
            </a>
          </li>
          <li v-if="!userinfo">
            <a v-bind:href="config.header_login_url" class="authButton" :style="config.loginButtonStyle">
              {{ config.login_button_label }}
              <Icon :icon="[config.iconStyle, 'right-to-bracket']"/>
            </a></li>
          <li v-if="userinfo">
            <a v-bind:href="config.header_logout_url" class="authButton" :style="config.loginButtonStyle">
              {{ config.logout_button_label }}
              <Icon :icon="[config.iconStyle, 'right-to-bracket']"/>
            </a>
          </li>
        </ul>
        <ul class="nav-bottom">
          <li v-for="(menu, index) in config.bottom_navbar_links" v-bind:key="index">
            <a :href="menu.type == 'link' ? menu.link :'#'" class="nav-link"
               :class="menu.type == 'link' ? 'dropdown' : ''">
              {{ menu.title }}
            </a>
            <ul class="drop-menu"
                v-if="menu.type == 'dropdown'">
              <li v-for="(childmenu, indexs) in menu.children" v-bind:key="indexs">
                <p v-if="childmenu.text">{{ childmenu.text }}</p>
                <a v-else :href="childmenu.link">
                  {{ childmenu.title }}
                </a>
              </li>
            </ul>
            <div class="mega-box" v-if="menu.type == 'megamenu'">
              <div class="content">
                <div v-for="(childmegamenu, indexmega) in menu.children" v-bind:key="indexmega"
                     class="row">
                  <header> {{ childmegamenu.title }}</header>
                  <ul class="mega-links">
                    <li v-for="(subchildmegamenu, subindexmega) in childmegamenu.children"
                        v-bind:key="subindexmega">
                      <a :href="subchildmegamenu.link">
                        {{ subchildmegamenu.title }}
                      </a>
                    </li>
                  </ul>
                </div>
              </div>
            </div>
          </li>
          <li v-for="(menuitem, indext) in config.top_navbar_links" v-bind:key="indext" class="menu-top-mobile">
            <a :href="menuitem.link" class="nav-link">
              {{ menuitem.title }}
              <Icon :icon="[config.iconStyle, menuitem.icon]"/>
            </a>
          </li>
          <li v-if="!userinfo" class="menu-top-mobile">
            <a v-bind:href="config.header_login_url" class="nav-link" :style="config.loginButtonStyle">
              {{ config.login_button_label }}
              <Icon :icon="[config.iconStyle, 'right-to-bracket']"/>
            </a></li>
          <li v-if="userinfo" class="menu-top-mobile">
            <a v-bind:href="config.header_logout_url" class="nav-link" :style="config.loginButtonStyle">
              {{ config.logout_button_label }}
              <Icon :icon="[config.iconStyle, 'right-to-bracket']"/>
            </a>
          </li>
        </ul>
        <ul class="nav-bottom-toggle">
          <ToggleButton v-if="show_toggle && userinfo" :options="this.toggleButtonConfig"></ToggleButton>
        </ul>
      </div>
    </div>
  </nav>
</template>

<script>
import "../assets/style/header.scss";

import Icon from "./Icon.vue";
import Logo from "./Logo.vue";
import ToggleButton from "./ToggleButton.vue";

export default {
  name: 'Header',
  components: {
    Icon,
    Logo,
    ToggleButton,
  },
  props: ['config', 'userinfo', 'show_toggle'],
  data() {
    return {
      toggleButtonConfig: this.config.toggleButtonConfig,
      menuIsOpen: false,
    }
  },
  methods: {
    menuToggle() {
      if (this.menuIsOpen) {
        this.menuIsOpen = false;
      } else {
        this.menuIsOpen = true;
      }
    }
  },
}
</script>
<style lang="scss" scoped>
.mobile-nav-toggle {
  display: none !important;
  @media screen and (max-width: 970px) {
    display: block !important;
  }
}

.nav-menu {
  .nav-bottom-toggle {
    @media screen and (max-width: 970px) {
      display: none !important;
    }
  }

  .nav-bottom {
    height: 50px !important;
    line-height: 50px !important;
  }

  .nav-bottom-toggle {
    justify-content: end;
    display: inline-flex;
    height: 60px;
    line-height: 10px;
    justify-content: end;
    padding-right: 10px;
    margin-top: 0px;
    padding-left: 0px;
  }
}
</style>
